unit fNonModalSearch;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uEstSearchDialog, uEstSearchDialogAdo, uEstSearchDialogConst;

type
  TFrmNonModalSearch = class(TForm)
    esdNonModal: TEstSearchDialogAdo;
    btnZoekNonModal: TButton;
    mmoLimitedSearch: TMemo;
    chbOpVoorgrond: TCheckBox;
    Label1: TLabel;
    lbxKlanten: TListBox;
    chbMDIChild: TCheckBox;
    procedure btnZoekNonModalClick(Sender: TObject);
    procedure esdNonModalSelect(Sender: TObject);
    procedure esdNonModalClose(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmNonModalSearch: TFrmNonModalSearch;

implementation

{$R *.dfm}

procedure TFrmNonModalSearch.btnZoekNonModalClick(Sender: TObject);
begin

  // Als de checkbox uitgeschakel is, dan is er een dialog operationeel en
  // hoeft en niets met de checkbox gedaan te worden
  if chbOpVoorgrond.Enabled then
  begin
    // Schakel de checkbox uit want SendToBackOnSelect kan niet gewijzigd worden
    // tijdens het zoeken
    chbOpVoorgrond.Enabled := False;

    // De SearchStyle kan natuurlijk ook niet gewijzigd worden tijdens het zoeken
    chbMDIChild.Enabled := False;

    // Stel dialog in volgens checkboxen
    if chbMDIChild.Checked then
      esdNonModal.SearchStyle := ssMDIChild
    else
      esdNonModal.SearchStyle := ssNormal;
  end;

  // Start het zoeken. Het resultaat van execute is niet interessant.
  esdNonModal.Execute;
end;

procedure TFrmNonModalSearch.esdNonModalSelect(Sender: TObject);
begin
  // Vul de lijst van gevonden klanten aan met het geselecteerde resultaat
  lbxKlanten.Items.Add(Format('%d - %s', [esdNonModal.ResultFieldAsInteger('custno'),
                                          esdNonModal.ResultFieldAsString('company')]));

  // Zet focus op form indien van toepassing
  if not chbOpVoorgrond.Enabled then
  begin
    if esdNonModal.SearchStyle = ssMDIChild then
      BringToFront
    else
      Application.MainForm.BringToFront;
  end;
end;

procedure TFrmNonModalSearch.esdNonModalClose(Sender: TObject);
begin
  // Het zoeken is afgelopen, zet de checkboxen weer aan
  chbOpVoorgrond.Enabled := True;
  chbMDIChild.Enabled := True;
end;

procedure TFrmNonModalSearch.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
