//---------------------------------------------------------------------------

#ifndef MiraGridH
#define MiraGridH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <Controls.hpp>
#include <Grids.hpp>
#include "Cell.h"
#include "Column.h"
#include <ComCtrls.hpp>

//---------------------------------------------------------------------------
class PACKAGE TMiraGrid : public TStringGrid
{
private:
void __fastcall SetupCellArray(void);
TComboBox *LastCombo;
TMonthCalendar *LastCalendar;
TEdit *LastEdit;
TImage *LastImage;


public:
  DynamicArray< DynamicArray<TCell*> > CellArray;
  DynamicArray<TColumn*> ColArray;
  int CCol;
  int CRow;
  __fastcall TMiraGrid(TComponent* Owner);
  void __fastcall DrawCell(int ACol, int ARow, const TRect &ARect, Grids::TGridDrawState AState);
  bool __fastcall SelectCell(int ACol, int ARow);
  void __fastcall SetColCount(int Cols);
  void __fastcall SetRowCount(int Rows);
  void __fastcall InsertRow(int AfterRow);
  void __fastcall DeleteRow(int Row);
  void __fastcall ComboChanged(TObject* Sender);
  void __fastcall CalendarChanged(TObject* Sender);
  void __fastcall EditChanged(TObject* Sender);
  void __fastcall RowButtonClicked(TObject* Sender);


  TComboBox* __fastcall ColCombo(int Col);
  TMonthCalendar* __fastcall ColCalendar(int Col);
  TEdit *__fastcall ColEdit(int Col);
  TBitBtn *__fastcall ColRowButton(int Col);
  void __fastcall InsertCombo(int Col);
  void __fastcall InsertCalendar(int Col);
  void __fastcall InsertEdit(int Col);
  void __fastcall InsertRowButton(int Col);
  TCell* __fastcall Cell(int Col,int Row);
  void __fastcall SetCanvas(int Col, int Row, TCanvas *Canvas);
  TCanvas* __fastcall GetCanvas(int Col, int Row);
  int __fastcall FindStringInCol(String string, int Col);

  //callbacks
  void __fastcall (__closure *OnSelectCellCallback)(int Col, int Row);
  void __fastcall (__closure *OnComboChangedCallback)(TObject* Sender);

};
//---------------------------------------------------------------------------
#endif
